extern "C" {
#include <APDS_INT.h>
#include <APDS_LED.h>
}
#include "apds.h"
#include "SparkFun_APDS9960.h"

static SparkFun_APDS9960 apds = SparkFun_APDS9960();

int apds_init(void)
{
	return apds.init() ? 1 : 0; 
}

int apds_enableGestureSensor(int interrupts)
{
	return apds.enableGestureSensor(interrupts ? true : false) ? 1 : 0; 
}

int apds_isGestureAvailable(void)
{
	return apds.isGestureAvailable() ? 1 : 0; 
}

int apds_readGesture(void)
{
	return apds.readGesture();
}

unsigned char apds_int_read(void)
{
	return APDS_INT_Read();
}

void apds_led_on(void)
{
	APDS_LED_Write(0);
	return;
}

void apds_led_off(void)
{
	APDS_LED_Write(1);
	return;
}
