/*
 *  TOPPERS Software
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 * 
 *  Copyright (C) 2008 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: start.S 2337 2012-04-04 15:06:33Z ertl-honda $
 */
                
/*
 *   J[lp̃X^[gAbvW[(ARM-Mp)
 */
#define TOPPERS_MACRO_ONLY
#define UINT_C(val)		(val)		/* uint_t^̒萔}N */
#define ULONG_C(val)	(val)		/* ulong_t^̒萔}N */
#define CAST(type, val)	(val)		/* ^LXgs}N */

#include "kernel_impl.h"
#include "arm_m.h"
#include "target_asm.inc"

/*
 *  X^[gAbv[`
 *
 *  Thread[hŌĂяo邱ƂOƂĂD
 */
	ATEXT
	ABALIGN(4)
	ATHUMB(_start)
	AGLOBAL(_start) 
ALABEL(_start)
	cpsid f                 /* ݃bNԂ */

#ifdef INIT_MSP
	/*
	 * MSP̐ݒ
	 */
	mov   r0, #CONTROL_MSP  /* MSPL  */
	msr   control, r0
	isb                     /* control ̑ɕKv */
	ldr  r0,=_kernel_istkpt
	ldr  r1,[r0]
	msr  msp, r1
#endif /* INIT_MSP */

	/*
	 * hardware_init_hooǩĂяo i0łȂꍇj
	 *
	 * ^[Qbgn[hEFAɈˑĕKvȏꍇ
	 * ́Chardware_init_hook Ƃ֐pӂ
	 */
	ldr  r0, =hardware_init_hook
	cbz  r0, start_1
	blx  r0

ALABEL(start_1)
#ifndef OMIT_BSS_INIT
	/*
	 *  BSSZNV
	 */
	mov  r0, #0
	ldr  r1, =BSS_START
	ldr  r2, =BSS_END
	cmp  r1, r2
	bhs  start_3
ALABEL(start_2)
	str  r0, [r1]
	add  r1,r1, #4    
	cmp  r1, r2
	blo  start_2
#endif /* OMIT_BSS_INIT */


ALABEL(start_3)
#ifndef OMIT_DATA_INIT
	/*
	 *  DATAZNV
	 *  __idata_start  __idata_end ܂łC__data_start ȍ~
	 *  Rs[
	 */
	ldr  r1, =IDATA_START
	ldr  r2, =IDATA_END
	cmp  r1, r2
	bhs  start_5
	ldr  r3, =DATA_START
ALABEL(start_4)
	ldr  r0, [r1]
	str  r0, [r3]
	add  r1, #4
	add  r3, #4
	cmp  r1, r2
	blo  start_4
#endif /* OMIT_DATA_INIT */

	/*
	 *  software_init_hook ďoi0 łȂꍇj
	 *
	 *  \tgEFAiɃCujɈˑĕKvȏ
	 *  ꍇ́Csoftware_init_hook Ƃ֐pӂ
	 *  悢D
	 */
ALABEL(start_5)
	ldr  r0, =software_init_hook
	cbz  r0, start_6
	blx  r0

ALABEL(start_6)
	bl   sta_ker

ALABEL(l_end)
	b   l_end
