#include "i2c.h"
#include <I2C_1.h>

#define APDS9960_ADR  0x39

void init_i2c(void)
{
	I2C_1_Start();
	return;
}

unsigned char I2C_READ(unsigned char REG_ADR)
{
	unsigned char data;
	I2C_1_MasterSendStart(APDS9960_ADR, 0);
	I2C_1_MasterWriteByte(REG_ADR);
	I2C_1_MasterSendStop();
	I2C_1_MasterSendStart(APDS9960_ADR, 1);
	data = I2C_1_MasterReadByte(0);
	I2C_1_MasterSendStop();
	return data;
}

int I2C_WRITE(unsigned char REG_ADR, unsigned char DATA)
{
	I2C_1_MasterSendStart(APDS9960_ADR, 0);
	I2C_1_MasterWriteByte(REG_ADR);
	I2C_1_MasterWriteByte(DATA);
	I2C_1_MasterSendStop();
	return 1;
}
