#include <pwm.h>
#include <PWM_LEDR.h>
#include <PWM_LEDG.h>
#include <PWM_LEDB.h>

void init_pwm(void)
{
	PWM_LEDR_Start();
	PWM_LEDG_Start();
	PWM_LEDB_Start();
	return;
}

void pwm_l_set(int r, int g, int b)
{
	PWM_LEDR_WriteCompare1(r * 100/ 256);
	PWM_LEDG_WriteCompare1(g * 100/ 256);
	PWM_LEDB_WriteCompare1(b * 100/ 256);
}

void pwm_r_set(int r, int g, int b)
{
	PWM_LEDR_WriteCompare2(r * 100/ 256);
	PWM_LEDG_WriteCompare2(g * 100/ 256);
	PWM_LEDB_WriteCompare2(b * 100/ 256);
}
